diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlNumberFormat.cpp webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlNumberFormat.cpp
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlNumberFormat.cpp	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlNumberFormat.cpp	2022-03-28 15:11:04.214708945 -0500
@@ -719,531 +306,56 @@ void IntlNumberFormat::initializeNumberF
         }
     }
 
-    switch (m_roundingType) {
-    case IntlRoundingType::FractionDigits:
+    if (!m_minimumSignificantDigits) {
         unum_setAttribute(m_numberFormat.get(), UNUM_MIN_INTEGER_DIGITS, m_minimumIntegerDigits);
         unum_setAttribute(m_numberFormat.get(), UNUM_MIN_FRACTION_DIGITS, m_minimumFractionDigits);
         unum_setAttribute(m_numberFormat.get(), UNUM_MAX_FRACTION_DIGITS, m_maximumFractionDigits);
-        break;
-    case IntlRoundingType::SignificantDigits:
+    } else {
         unum_setAttribute(m_numberFormat.get(), UNUM_SIGNIFICANT_DIGITS_USED, true);
         unum_setAttribute(m_numberFormat.get(), UNUM_MIN_SIGNIFICANT_DIGITS, m_minimumSignificantDigits);
         unum_setAttribute(m_numberFormat.get(), UNUM_MAX_SIGNIFICANT_DIGITS, m_maximumSignificantDigits);
-        break;
-    case IntlRoundingType::MorePrecision:
-        // Ignore this case since linked ICU does not support it.
-        break;
-    case IntlRoundingType::LessPrecision:
-        // Ignore this case since linked ICU does not support it.
-        break;
-    }
-
-    switch (m_useGrouping) {
-    case UseGrouping::False:
-        unum_setAttribute(m_numberFormat.get(), UNUM_GROUPING_USED, false);
-        break;
-    case UseGrouping::Min2:
-        // Ignore this case since linked ICU does not support it.
-        break;
-    case UseGrouping::Auto:
-        break;
-    case UseGrouping::Always:
-        unum_setAttribute(m_numberFormat.get(), UNUM_GROUPING_USED, true);
-        break;
     }
+    unum_setAttribute(m_numberFormat.get(), UNUM_GROUPING_USED, m_useGrouping);
     unum_setAttribute(m_numberFormat.get(), UNUM_ROUNDING_MODE, UNUM_ROUND_HALFUP);
-#endif
 }
 
 // https://tc39.es/ecma402/#sec-formatnumber
 JSValue IntlNumberFormat::format(JSGlobalObject* globalObject, double value) const
 {
+    ASSERT(m_numberFormat);
+
     VM& vm = globalObject->vm();
     auto scope = DECLARE_THROW_SCOPE(vm);
 
     Vector<UChar, 32> buffer;
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-    ASSERT(m_numberFormatter);
-    UErrorCode status = U_ZERO_ERROR;
-    auto formattedNumber = std::unique_ptr<UFormattedNumber, ICUDeleter<unumf_closeResult>>(unumf_openResult(&status));
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "Failed to format a number."_s);
-    unumf_formatDouble(m_numberFormatter.get(), value, formattedNumber.get(), &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "Failed to format a number."_s);
-    status = callBufferProducingFunction(unumf_resultToString, formattedNumber.get(), buffer);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "Failed to format a number."_s);
-#else
-    ASSERT(m_numberFormat);
     auto status = callBufferProducingFunction(unum_formatDouble, m_numberFormat.get(), value, buffer, nullptr);
     if (U_FAILURE(status))
+
         return throwTypeError(globalObject, scope, "Failed to format a number."_s);
-#endif
-    return jsString(vm, String(WTFMove(buffer)));
+    return jsString(vm, String(buffer));
 }
 
 // https://tc39.es/ecma402/#sec-formatnumber
-JSValue IntlNumberFormat::format(JSGlobalObject* globalObject, IntlMathematicalValue&& value) const
+JSValue IntlNumberFormat::format(JSGlobalObject* globalObject, JSBigInt* value) const
 {
-    VM& vm = globalObject->vm();
-    auto scope = DECLARE_THROW_SCOPE(vm);
-
-    value.ensureNonDouble();
-    const auto& string = value.getString();
-
-    Vector<UChar, 32> buffer;
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-    ASSERT(m_numberFormatter);
-    UErrorCode status = U_ZERO_ERROR;
-    auto formattedNumber = std::unique_ptr<UFormattedNumber, ICUDeleter<unumf_closeResult>>(unumf_openResult(&status));
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "Failed to format a BigInt."_s);
-    unumf_formatDecimal(m_numberFormatter.get(), string.data(), string.length(), formattedNumber.get(), &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "Failed to format a BigInt."_s);
-    status = callBufferProducingFunction(unumf_resultToString, formattedNumber.get(), buffer);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "Failed to format a BigInt."_s);
-#else
     ASSERT(m_numberFormat);
-    auto status = callBufferProducingFunction(unum_formatDecimal, m_numberFormat.get(), string.data(), string.length(), buffer, nullptr);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "Failed to format a BigInt."_s);
-#endif
-    return jsString(vm, String(WTFMove(buffer)));
-}
-
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-JSValue IntlNumberFormat::formatRange(JSGlobalObject* globalObject, double start, double end) const
-{
-    VM& vm = globalObject->vm();
-    auto scope = DECLARE_THROW_SCOPE(vm);
-
-    ASSERT(m_numberRangeFormatter);
-
-    if (std::isnan(start) || std::isnan(end))
-        return throwRangeError(globalObject, scope, "Passed numbers are out of range"_s);
-
-    if (end < start)
-        return throwRangeError(globalObject, scope, "start is larger than end"_s);
-
-    if (isNegativeZero(end) && start >= 0)
-        return throwRangeError(globalObject, scope, "start is larger than end"_s);
-
-    UErrorCode status = U_ZERO_ERROR;
-    auto range = std::unique_ptr<UFormattedNumberRange, ICUDeleter<unumrf_closeResult>>(unumrf_openResult(&status));
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    unumrf_formatDoubleRange(m_numberRangeFormatter.get(), start, end, range.get(), &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    auto* formattedValue = unumrf_resultAsValue(range.get(), &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    int32_t length = 0;
-    const UChar* string = ufmtval_getString(formattedValue, &length, &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    return jsString(vm, String(string, length));
-}
-
-JSValue IntlNumberFormat::formatRange(JSGlobalObject* globalObject, IntlMathematicalValue&& start, IntlMathematicalValue&& end) const
-{
-    VM& vm = globalObject->vm();
-    auto scope = DECLARE_THROW_SCOPE(vm);
-
-    ASSERT(m_numberRangeFormatter);
-
-    if (start.numberType() == IntlMathematicalValue::NumberType::NaN || end.numberType() == IntlMathematicalValue::NumberType::NaN)
-        return throwRangeError(globalObject, scope, "Passed numbers are out of range"_s);
-
-    start.ensureNonDouble();
-    const auto& startString = start.getString();
-
-    end.ensureNonDouble();
-    const auto& endString = end.getString();
-
-    UErrorCode status = U_ZERO_ERROR;
-    auto range = std::unique_ptr<UFormattedNumberRange, ICUDeleter<unumrf_closeResult>>(unumrf_openResult(&status));
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    unumrf_formatDecimalRange(m_numberRangeFormatter.get(), startString.data(), startString.length(), endString.data(), endString.length(), range.get(), &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    auto* formattedValue = unumrf_resultAsValue(range.get(), &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    int32_t length = 0;
-    const UChar* string = ufmtval_getString(formattedValue, &length, &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    return jsString(vm, String(string, length));
-}
-#endif
-
-static constexpr int32_t literalField = -1;
-struct IntlNumberFormatField {
-    int32_t m_field;
-    WTF::Range<int32_t> m_range;
-};
-
-static Vector<IntlNumberFormatField> flattenFields(Vector<IntlNumberFormatField>&& fields, int32_t formattedStringLength)
-{
-    // ICU generates sequence of nested fields, but ECMA402 requires non-overlapping sequence of parts.
-    // This function flattens nested fields into sequence of non-overlapping parts.
-    //
-    // Formatted string: "100,000–20,000,000"
-    //                    |  |  | | |   |  |
-    //                    |  B  | | E   F  |
-    //                    |     | |        |
-    //                    +--C--+ +---G----+
-    //                    +--A--+ +---D----+
-    //
-    // Ranges ICU generates:
-    //     A:    (0, 7)   UFIELD_CATEGORY_NUMBER_RANGE_SPAN startRange
-    //     B:    (3, 4)   UFIELD_CATEGORY_NUMBER group ","
-    //     C:    (0, 7)   UFIELD_CATEGORY_NUMBER integer
-    //     D:    (8, 18)  UFIELD_CATEGORY_NUMBER_RANGE_SPAN endRange
-    //     E:    (10, 11) UFIELD_CATEGORY_NUMBER group ","
-    //     F:    (14, 15) UFIELD_CATEGORY_NUMBER group ","
-    //     G:    (8, 18)  UFIELD_CATEGORY_NUMBER integer
-    //
-    // Then, we need to generate:
-    //     A:    (0, 3)   startRange integer
-    //     B:    (3, 4)   startRange group ","
-    //     C:    (4, 7)   startRange integer
-    //     D:    (7, 8)   shared     literal "-"
-    //     E:    (8, 10)  endRange   integer
-    //     F:    (10, 11) endRange   group ","
-    //     G:    (11, 14) endRange   integer
-    //     H:    (14, 15) endRange   group ","
-    //     I:    (15, 18) endRange   integer
-
-    std::sort(fields.begin(), fields.end(), [](auto& lhs, auto& rhs) {
-        if (lhs.m_range.begin() < rhs.m_range.begin())
-            return true;
-        if (lhs.m_range.begin() > rhs.m_range.begin())
-            return false;
-        if (lhs.m_range.end() < rhs.m_range.end())
-            return false;
-        if (lhs.m_range.end() > rhs.m_range.end())
-            return true;
-        return lhs.m_field < rhs.m_field;
-    });
-
-    Vector<IntlNumberFormatField> flatten;
-    Vector<IntlNumberFormatField> stack;
-    // Top-level field covers entire parts, which makes parts "literal".
-    stack.append(IntlNumberFormatField { literalField, { 0, formattedStringLength } });
-
-    unsigned cursor = 0;
-    int32_t begin = 0;
-    while (cursor < fields.size()) {
-        const auto& field = fields[cursor];
-
-        // If the new field is out of the current top-most field, roll up and insert a flatten field.
-        // Because the top-level field in the stack covers all index range, this condition always becomes false
-        // if stack size is 1.
-        while (stack.last().m_range.end() < field.m_range.begin()) {
-            if (begin < stack.last().m_range.end()) {
-                IntlNumberFormatField flattenField { stack.last().m_field, { begin, stack.last().m_range.end() } };
-                flatten.append(flattenField);
-                begin = flattenField.m_range.end();
-            }
-            stack.removeLast();
-        }
-        ASSERT(!stack.isEmpty()); // At least, top-level field exists.
-
-        // If the new field is starting with the same index, diving into the new field by adding it into stack.
-        if (begin == field.m_range.begin()) {
-            stack.append(field);
-            ++cursor;
-            continue;
-        }
-
-        // If there is a room between the current top-most field and the new field, insert a flatten field.
-        if (begin < field.m_range.begin()) {
-            IntlNumberFormatField flattenField { stack.last().m_field, { begin, field.m_range.begin() } };
-            flatten.append(flattenField);
-            stack.append(field);
-            begin = field.m_range.begin();
-            ++cursor;
-            continue;
-        }
-    }
-
-    // Roll up the nested field at the end of the formatted string sequence.
-    // For example,
-    //
-    //      <------------A-------------->
-    //      <--------B------------>
-    //      <---C---->
-    //
-    // Then, after C finishes, we should insert remaining B and A.
-    while (!stack.isEmpty()) {
-        if (begin < stack.last().m_range.end()) {
-            IntlNumberFormatField flattenField { stack.last().m_field, { begin, stack.last().m_range.end() } };
-            flatten.append(flattenField);
-            begin = flattenField.m_range.end();
-        }
-        stack.removeLast();
-    }
 
-    return flatten;
-}
-
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER_FORMAT_RANGE_TO_PARTS)
-static bool numberFieldsPracticallyEqual(const UFormattedValue* formattedValue, UErrorCode& status)
-{
-    auto iterator = std::unique_ptr<UConstrainedFieldPosition, ICUDeleter<ucfpos_close>>(ucfpos_open(&status));
-    if (U_FAILURE(status))
-        return false;
-
-    // We only care about UFIELD_CATEGORY_NUMBER_RANGE_SPAN category.
-    ucfpos_constrainCategory(iterator.get(), UFIELD_CATEGORY_NUMBER_RANGE_SPAN, &status);
-    if (U_FAILURE(status))
-        return false;
-
-    bool hasSpan = ufmtval_nextPosition(formattedValue, iterator.get(), &status);
-    if (U_FAILURE(status))
-        return false;
-
-    return !hasSpan;
-}
-
-void IntlNumberFormat::formatRangeToPartsInternal(JSGlobalObject* globalObject, Style style, IntlMathematicalValue&& start, IntlMathematicalValue&& end, const UFormattedValue* formattedValue, JSArray* parts)
-{
-    VM& vm = globalObject->vm();
-    auto scope = DECLARE_THROW_SCOPE(vm);
-
-    UErrorCode status = U_ZERO_ERROR;
-
-    int32_t formattedStringLength = 0;
-    const UChar* formattedStringPointer = ufmtval_getString(formattedValue, &formattedStringLength, &status);
-    if (U_FAILURE(status)) {
-        throwTypeError(globalObject, scope, "Failed to format number range"_s);
-        return;
-    }
-    String resultString(formattedStringPointer, formattedStringLength);
-
-    // We care multiple categories (UFIELD_CATEGORY_DATE and UFIELD_CATEGORY_DATE_INTERVAL_SPAN).
-    // So we do not constraint iterator.
-    auto iterator = std::unique_ptr<UConstrainedFieldPosition, ICUDeleter<ucfpos_close>>(ucfpos_open(&status));
-    if (U_FAILURE(status)) {
-        throwTypeError(globalObject, scope, "Failed to format number range"_s);
-        return;
-    }
-
-    auto sharedString = jsNontrivialString(vm, "shared"_s);
-    auto startRangeString = jsNontrivialString(vm, "startRange"_s);
-    auto endRangeString = jsNontrivialString(vm, "endRange"_s);
-    auto literalString = jsNontrivialString(vm, "literal"_s);
-
-    WTF::Range<int32_t> startRange { -1, -1 };
-    WTF::Range<int32_t> endRange { -1, -1 };
-    Vector<IntlNumberFormatField> fields;
-
-    while (true) {
-        bool next = ufmtval_nextPosition(formattedValue, iterator.get(), &status);
-        if (U_FAILURE(status)) {
-            throwTypeError(globalObject, scope, "Failed to format number range"_s);
-            return;
-        }
-        if (!next)
-            break;
-
-        int32_t category = ucfpos_getCategory(iterator.get(), &status);
-        if (U_FAILURE(status)) {
-            throwTypeError(globalObject, scope, "Failed to format number range"_s);
-            return;
-        }
-
-        int32_t fieldType = ucfpos_getField(iterator.get(), &status);
-        if (U_FAILURE(status)) {
-            throwTypeError(globalObject, scope, "Failed to format number range"_s);
-            return;
-        }
-
-        int32_t beginIndex = 0;
-        int32_t endIndex = 0;
-        ucfpos_getIndexes(iterator.get(), &beginIndex, &endIndex, &status);
-        if (U_FAILURE(status)) {
-            throwTypeError(globalObject, scope, "Failed to format number interval"_s);
-            return;
-        }
-
-        dataLogLnIf(IntlNumberFormatInternal::verbose, category, " ", fieldType, " (", beginIndex, ", ", endIndex, ")");
-
-        if (category != UFIELD_CATEGORY_NUMBER && category != UFIELD_CATEGORY_NUMBER_RANGE_SPAN)
-            continue;
-        if (category == UFIELD_CATEGORY_NUMBER && fieldType < 0)
-            continue;
-
-        if (category == UFIELD_CATEGORY_NUMBER_RANGE_SPAN) {
-            // > The special field category UFIELD_CATEGORY_NUMBER_RANGE_SPAN is used to indicate which number
-            // > primitives came from which arguments: 0 means start, and 1 means end. The span category
-            // > will always occur before the corresponding fields in UFIELD_CATEGORY_NUMBER in the nextPosition() iterator.
-            // from ICU comment. So, field 0 is startRange, field 1 is endRange.
-            if (!fieldType)
-                startRange = WTF::Range<int32_t>(beginIndex, endIndex);
-            else {
-                ASSERT(fieldType == 1);
-                endRange = WTF::Range<int32_t>(beginIndex, endIndex);
-            }
-            continue;
-        }
-
-        ASSERT(category == UFIELD_CATEGORY_NUMBER);
-
-        fields.append(IntlNumberFormatField { fieldType, { beginIndex, endIndex } });
-    }
-
-    auto flatten = flattenFields(WTFMove(fields), formattedStringLength);
-
-    auto createPart = [&] (JSString* type, int32_t beginIndex, int32_t length) {
-        auto sourceType = [&](int32_t index) -> JSString* {
-            if (startRange.contains(index))
-                return startRangeString;
-            if (endRange.contains(index))
-                return endRangeString;
-            return sharedString;
-        };
-
-        auto value = jsString(vm, resultString.substring(beginIndex, length));
-        JSObject* part = constructEmptyObject(globalObject);
-        part->putDirect(vm, vm.propertyNames->type, type);
-        part->putDirect(vm, vm.propertyNames->value, value);
-        part->putDirect(vm, vm.propertyNames->source, sourceType(beginIndex));
-        return part;
-    };
-
-    for (auto& field : flatten) {
-        bool sign = false;
-        IntlMathematicalValue::NumberType numberType = start.numberType();
-        if (startRange.contains(field.m_range.begin())) {
-            numberType = start.numberType();
-            sign = start.sign();
-        } else {
-            numberType = end.numberType();
-            sign = end.sign();
-        }
-        auto fieldType = field.m_field;
-        auto partType = fieldType == literalField ? literalString : jsString(vm, partTypeString(UNumberFormatFields(fieldType), style, sign, numberType));
-        JSObject* part = createPart(partType, field.m_range.begin(), field.m_range.distance());
-        parts->push(globalObject, part);
-        RETURN_IF_EXCEPTION(scope, void());
-    }
-}
-
-JSValue IntlNumberFormat::formatRangeToParts(JSGlobalObject* globalObject, double start, double end) const
-{
     VM& vm = globalObject->vm();
     auto scope = DECLARE_THROW_SCOPE(vm);
 
-    ASSERT(m_numberRangeFormatter);
-
-    if (std::isnan(start) || std::isnan(end))
-        return throwRangeError(globalObject, scope, "Passed numbers are out of range"_s);
-
-    if (end < start)
-        return throwRangeError(globalObject, scope, "start is larger than end"_s);
-
-    if (isNegativeZero(end) && start >= 0)
-        return throwRangeError(globalObject, scope, "start is larger than end"_s);
-
-    UErrorCode status = U_ZERO_ERROR;
-    auto range = std::unique_ptr<UFormattedNumberRange, ICUDeleter<unumrf_closeResult>>(unumrf_openResult(&status));
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    unumrf_formatDoubleRange(m_numberRangeFormatter.get(), start, end, range.get(), &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    auto* formattedValue = unumrf_resultAsValue(range.get(), &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    bool equal = numberFieldsPracticallyEqual(formattedValue, status);
-    if (U_FAILURE(status)) {
-        throwTypeError(globalObject, scope, "Failed to format number range"_s);
-        return { };
-    }
-
-    if (equal)
-        RELEASE_AND_RETURN(scope, formatToParts(globalObject, start, jsNontrivialString(vm, "shared"_s)));
-
-    JSArray* parts = JSArray::tryCreate(vm, globalObject->arrayStructureForIndexingTypeDuringAllocation(ArrayWithContiguous), 0);
-    if (!parts) {
-        throwOutOfMemoryError(globalObject, scope);
-        return { };
-    }
-
-    formatRangeToPartsInternal(globalObject, m_style, IntlMathematicalValue(start), IntlMathematicalValue(end), formattedValue, parts);
+    auto string = value->toString(globalObject, 10);
     RETURN_IF_EXCEPTION(scope, { });
 
-    return parts;
-}
-
-JSValue IntlNumberFormat::formatRangeToParts(JSGlobalObject* globalObject, IntlMathematicalValue&& start, IntlMathematicalValue&& end) const
-{
-    VM& vm = globalObject->vm();
-    auto scope = DECLARE_THROW_SCOPE(vm);
-
-    ASSERT(m_numberRangeFormatter);
-
-    if (start.numberType() == IntlMathematicalValue::NumberType::NaN || end.numberType() == IntlMathematicalValue::NumberType::NaN)
-        return throwRangeError(globalObject, scope, "Passed numbers are out of range"_s);
-
-    start.ensureNonDouble();
-    const auto& startString = start.getString();
-
-    end.ensureNonDouble();
-    const auto& endString = end.getString();
+    ASSERT(string.is8Bit() && string.isAllASCII());
+    auto* rawString = reinterpret_cast<const char*>(string.characters8());
 
-    UErrorCode status = U_ZERO_ERROR;
-    auto range = std::unique_ptr<UFormattedNumberRange, ICUDeleter<unumrf_closeResult>>(unumrf_openResult(&status));
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    unumrf_formatDecimalRange(m_numberRangeFormatter.get(), startString.data(), startString.length(), endString.data(), endString.length(), range.get(), &status);
-    if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    auto* formattedValue = unumrf_resultAsValue(range.get(), &status);
+    Vector<UChar, 32> buffer;
+    auto status = callBufferProducingFunction(unum_formatDecimal, m_numberFormat.get(), rawString, string.length(), buffer, nullptr);
     if (U_FAILURE(status))
-        return throwTypeError(globalObject, scope, "failed to format a range"_s);
-
-    bool equal = numberFieldsPracticallyEqual(formattedValue, status);
-    if (U_FAILURE(status)) {
-        throwTypeError(globalObject, scope, "Failed to format number range"_s);
-        return { };
-    }
-
-    if (equal)
-        RELEASE_AND_RETURN(scope, formatToParts(globalObject, WTFMove(start), jsNontrivialString(vm, "shared"_s)));
-
-    JSArray* parts = JSArray::tryCreate(vm, globalObject->arrayStructureForIndexingTypeDuringAllocation(ArrayWithContiguous), 0);
-    if (!parts) {
-        throwOutOfMemoryError(globalObject, scope);
-        return { };
-    }
-
-    formatRangeToPartsInternal(globalObject, m_style, WTFMove(start), WTFMove(end), formattedValue, parts);
-    RETURN_IF_EXCEPTION(scope, { });
+        return throwTypeError(globalObject, scope, "Failed to format a BigInt."_s);
 
-    return parts;
+    return jsString(vm, String(buffer));
 }
-#endif
 
 ASCIILiteral IntlNumberFormat::styleString(Style style)
 {
@@ -1254,8 +366,6 @@ ASCIILiteral IntlNumberFormat::styleStri
         return "percent"_s;
     case Style::Currency:
         return "currency"_s;
-    case Style::Unit:
-        return "unit"_s;
     }
     ASSERT_NOT_REACHED();
     return ASCIILiteral::null();
@@ -1268,8 +378,6 @@ ASCIILiteral IntlNumberFormat::currencyD
         return "code"_s;
     case CurrencyDisplay::Symbol:
         return "symbol"_s;
-    case CurrencyDisplay::NarrowSymbol:
-        return "narrowSymbol"_s;
     case CurrencyDisplay::Name:
         return "name"_s;
     }
@@ -1277,146 +385,6 @@ ASCIILiteral IntlNumberFormat::currencyD
     return ASCIILiteral::null();
 }
 
-ASCIILiteral IntlNumberFormat::notationString(IntlNotation notation)
-{
-    switch (notation) {
-    case IntlNotation::Standard:
-        return "standard"_s;
-    case IntlNotation::Scientific:
-        return "scientific"_s;
-    case IntlNotation::Engineering:
-        return "engineering"_s;
-    case IntlNotation::Compact:
-        return "compact"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
-}
-
-ASCIILiteral IntlNumberFormat::currencySignString(CurrencySign currencySign)
-{
-    switch (currencySign) {
-    case CurrencySign::Standard:
-        return "standard"_s;
-    case CurrencySign::Accounting:
-        return "accounting"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
-}
-
-ASCIILiteral IntlNumberFormat::unitDisplayString(UnitDisplay unitDisplay)
-{
-    switch (unitDisplay) {
-    case UnitDisplay::Short:
-        return "short"_s;
-    case UnitDisplay::Narrow:
-        return "narrow"_s;
-    case UnitDisplay::Long:
-        return "long"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
-}
-
-ASCIILiteral IntlNumberFormat::compactDisplayString(CompactDisplay compactDisplay)
-{
-    switch (compactDisplay) {
-    case CompactDisplay::Short:
-        return "short"_s;
-    case CompactDisplay::Long:
-        return "long"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
-}
-
-ASCIILiteral IntlNumberFormat::signDisplayString(SignDisplay signDisplay)
-{
-    switch (signDisplay) {
-    case SignDisplay::Auto:
-        return "auto"_s;
-    case SignDisplay::Never:
-        return "never"_s;
-    case SignDisplay::Always:
-        return "always"_s;
-    case SignDisplay::ExceptZero:
-        return "exceptZero"_s;
-    case SignDisplay::Negative:
-        return "negative"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
-}
-
-ASCIILiteral IntlNumberFormat::roundingModeString(RoundingMode roundingMode)
-{
-    switch (roundingMode) {
-    case RoundingMode::Ceil:
-        return "ceil"_s;
-    case RoundingMode::Floor:
-        return "floor"_s;
-    case RoundingMode::Expand:
-        return "expand"_s;
-    case RoundingMode::Trunc:
-        return "trunc"_s;
-    case RoundingMode::HalfCeil:
-        return "halfCeil"_s;
-    case RoundingMode::HalfFloor:
-        return "halfFloor"_s;
-    case RoundingMode::HalfExpand:
-        return "halfExpand"_s;
-    case RoundingMode::HalfTrunc:
-        return "halfTrunc"_s;
-    case RoundingMode::HalfEven:
-        return "halfEven"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
-}
-
-ASCIILiteral IntlNumberFormat::trailingZeroDisplayString(TrailingZeroDisplay trailingZeroDisplay)
-{
-    switch (trailingZeroDisplay) {
-    case TrailingZeroDisplay::Auto:
-        return "auto"_s;
-    case TrailingZeroDisplay::StripIfInteger:
-        return "stripIfInteger"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
-}
-
-ASCIILiteral IntlNumberFormat::roundingPriorityString(IntlRoundingType roundingType)
-{
-    switch (roundingType) {
-    case IntlRoundingType::FractionDigits:
-    case IntlRoundingType::SignificantDigits:
-        return "auto"_s;
-    case IntlRoundingType::MorePrecision:
-        return "morePrecision"_s;
-    case IntlRoundingType::LessPrecision:
-        return "lessPrecision"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
-}
-
-JSValue IntlNumberFormat::useGroupingValue(VM& vm, UseGrouping useGrouping)
-{
-    switch (useGrouping) {
-    case UseGrouping::False:
-        return jsBoolean(false);
-    case UseGrouping::Min2:
-        return jsNontrivialString(vm, "min2"_s);
-    case UseGrouping::Auto:
-        return jsNontrivialString(vm, "auto"_s);
-    case UseGrouping::Always:
-        return jsNontrivialString(vm, "always"_s);
-    }
-    return jsUndefined();
-}
-
 // https://tc39.es/ecma402/#sec-intl.numberformat.prototype.resolvedoptions
 JSObject* IntlNumberFormat::resolvedOptions(JSGlobalObject* globalObject) const
 {
